local gt = this.getroottable();

if (!("BackgroundPerks" in gt.Const))
{
	gt.Const.BackgroundPerks <- {};
	gt.Const.BackgroundPerks.Data <- {};
	gt.Const.BackgroundPerks.TraitCost <- {};
}
//companion_1h, companion_2h, companion_ranged

gt.Const.BackgroundPerks.Data["background.adventurous_noble"] <- ["perk.shield_expert", "perk.relentless", "perk.rotation", "perk.gifted", "perk.taunt", "perk.nine_lives"];
gt.Const.BackgroundPerks.Data["background.apprentice"] <- ["perk.student", "perk.gifted", "perk.fast_adaption", "perk.recover", "perk.brawny", "perk.relentless"];
gt.Const.BackgroundPerks.Data["background.assassin"] <- ["perk.backstabber", "perk.coup_de_grace", "perk.fast_adaption", "perk.dodge", "perk.anticipation", "perk.fortified_mind"];
gt.Const.BackgroundPerks.Data["background.barbarian"] <- ["perk.crippling_strikes", "perk.adrenaline", "perk.brawny", "perk.coup_de_grace", "perk.relentless", "perk.colossus"];
gt.Const.BackgroundPerks.Data["background.bastard"] <- ["perk.gifted", "perk.relentless", "perk.taunt", "perk.backstabber", "perk.shield_expert", "perk.student"];
gt.Const.BackgroundPerks.Data["background.beast_hunter"] <- ["perk.bullseye", "perk.anticipation", "perk.dodge", "perk.nine_lives", "perk.fast_adaption", "perk.gifted"];
gt.Const.BackgroundPerks.Data["background.beggar"] <- ["perk.bags_and_belts", "perk.backstabber", "perk.dodge", "perk.pathfinder", "perk.anticipation", "perk.nine_lives"];
gt.Const.BackgroundPerks.Data["background.bowyer"] <- ["perk.bullseye", "perk.gifted", "perk.student", "perk.bags_and_belts", "perk.fast_adaption", "perk.quick_hands"];
gt.Const.BackgroundPerks.Data["background.brawler"] <- ["perk.colossus", "perk.coup_de_grace", "perk.dodge", "perk.hold_out", "perk.steel_brow", "perk.taunt"];
gt.Const.BackgroundPerks.Data["background.butcher"] <- ["perk.crippling_strikes", "perk.coup_de_grace", "perk.adrenaline", "perk.brawny", "perk.student", "perk.colossus"];
gt.Const.BackgroundPerks.Data["background.caravan_hand"] <- ["perk.bags_and_belts", "perk.recover", "perk.shield_expert", "perk.brawny", "perk.rotation", "perk.student"];
gt.Const.BackgroundPerks.Data["background.cripple"] <- ["perk.nine_lives", "perk.fortified_mind", "perk.hold_out", "perk.steel_brow", "perk.backstabber", "perk.quick_hands"];
gt.Const.BackgroundPerks.Data["background.cultist"] <- ["perk.crippling_strikes", "perk.steel_brow", "perk.adrenaline", "perk.nine_lives", "perk.backstabber", "perk.fortified_mind"];
gt.Const.BackgroundPerks.Data["background.daytaler"] <- ["perk.colossus", "perk.recover", "perk.brawny", "perk.pathfinder", "perk.student", "perk.bags_and_belts"];
gt.Const.BackgroundPerks.Data["background.deserter"] <- ["perk.shield_expert", "perk.rotation", "perk.nine_lives", "perk.adrenaline", "perk.steel_brow", "perk.brawny"];
gt.Const.BackgroundPerks.Data["background.disowned_noble"] <- ["perk.shield_expert", "perk.relentless", "perk.rotation", "perk.gifted", "perk.pathfinder", "perk.fortified_mind"];
gt.Const.BackgroundPerks.Data["background.eunuch"] <- ["perk.fortified_mind", "perk.hold_out", "perk.recover", "perk.student", "perk.steel_brow", "perk.nine_lives"];
gt.Const.BackgroundPerks.Data["background.farmhand"] <- ["perk.recover", "perk.colossus", "perk.brawny", "perk.hold_out", "perk.pathfinder", "perk.relentless"];
gt.Const.BackgroundPerks.Data["background.fisherman"] <- ["perk.recover", "perk.colossus", "perk.brawny", "perk.coup_de_grace", "perk.quick_hands", "perk.adrenaline"];
gt.Const.BackgroundPerks.Data["background.flagellant"] <- ["perk.nine_lives", "perk.adrenaline", "perk.fortified_mind", "perk.taunt", "perk.crippling_strikes", "perk.hold_out"];
gt.Const.BackgroundPerks.Data["background.gambler"] <- ["perk.bags_and_belts", "perk.quick_hands", "perk.fast_adaption", "perk.backstabber", "perk.anticipation", "perk.student"];
gt.Const.BackgroundPerks.Data["background.gravedigger"] <- ["perk.fortified_mind", "perk.adrenaline", "perk.student", "perk.recover", "perk.relentless", "perk.colossus"];
gt.Const.BackgroundPerks.Data["background.graverobber"] <- ["perk.fortified_mind", "perk.adrenaline", "perk.student", "perk.backstabber", "perk.relentless", "perk.gifted"];
gt.Const.BackgroundPerks.Data["background.hedge_knight"] <- ["perk.relentless", "perk.shield_expert", "perk.steel_brow", "perk.coup_de_grace", "perk.brawny", "perk.fortified_mind"];
gt.Const.BackgroundPerks.Data["background.historian"] <- ["perk.student", "perk.rotation", "perk.bags_and_belts", "perk.rally_the_troops", "perk.fast_adaption", "perk.gifted"];
gt.Const.BackgroundPerks.Data["background.houndmaster"] <- ["perk.adrenaline", "perk.taunt", "perk.coup_de_grace", "perk.rally_the_troops", "perk.dodge", "perk.backstabber"];
gt.Const.BackgroundPerks.Data["background.hunter"] <- ["perk.bullseye", "perk.pathfinder", "perk.anticipation", "perk.coup_de_grace", "perk.gifted", "perk.relentless"];
gt.Const.BackgroundPerks.Data["background.juggler"] <- ["perk.rally_the_troops", "perk.fast_adaption", "perk.dodge", "perk.gifted", "perk.adrenaline", "perk.taunt"];
gt.Const.BackgroundPerks.Data["background.killer_on_the_run"] <- ["perk.backstabber", "perk.coup_de_grace", "perk.pathfinder", "perk.anticipation", "perk.fast_adaption", "perk.fortified_mind"];
gt.Const.BackgroundPerks.Data["background.lumberjack"] <- ["perk.colossus", "perk.crippling_strikes", "perk.recover", "perk.hold_out", "perk.steel_brow", "perk.brawny"];
gt.Const.BackgroundPerks.Data["background.mason"] <- ["perk.recover", "perk.hold_out", "perk.steel_brow", "perk.brawny", "perk.crippling_strikes", "perk.gifted"];
gt.Const.BackgroundPerks.Data["background.messenger"] <- ["perk.rally_the_troops", "perk.pathfinder", "perk.dodge", "perk.rotation", "perk.relentless", "perk.bags_and_belts"];
gt.Const.BackgroundPerks.Data["background.militia"] <- ["perk.relentless", "perk.rotation", "perk.taunt", "perk.colossus", "perk.shield_expert", "perk.steel_brow"];
gt.Const.BackgroundPerks.Data["background.miller"] <- ["perk.recover", "perk.colossus", "perk.brawny", "perk.steel_brow", "perk.student", "perk.bags_and_belts"];
gt.Const.BackgroundPerks.Data["background.miner"] <- ["perk.recover", "perk.colossus", "perk.brawny", "perk.steel_brow", "perk.crippling_strikes", "perk.relentless"];
gt.Const.BackgroundPerks.Data["background.minstrel"] <- ["perk.student", "perk.rally_the_troops", "perk.pathfinder", "perk.relentless", "perk.recover", "perk.gifted"];
gt.Const.BackgroundPerks.Data["background.monk"] <- ["perk.student", "perk.rally_the_troops", "perk.nine_lives", "perk.anticipation", "perk.fortified_mind", "perk.hold_out"];
gt.Const.BackgroundPerks.Data["background.peddler"] <- ["perk.student", "perk.gifted", "perk.fast_adaption", "perk.rally_the_troops", "perk.taunt", "perk.backstabber"];
gt.Const.BackgroundPerks.Data["background.pimp"] <- ["perk.rally_the_troops", "perk.gifted", "perk.backstabber", "perk.taunt", "perk.quick_hands", "perk.fortified_mind"];
gt.Const.BackgroundPerks.Data["background.poacher"] <- ["perk.bullseye", "perk.anticipation", "perk.fast_adaption", "perk.crippling_strikes", "perk.nine_lives", "perk.bags_and_belts"];
gt.Const.BackgroundPerks.Data["background.raider"] <- ["perk.crippling_strikes", "perk.coup_de_grace", "perk.adrenaline", "perk.pathfinder", "perk.bags_and_belts", "perk.backstabber"];
gt.Const.BackgroundPerks.Data["background.ratcatcher"] <- ["perk.quick_hands", "perk.coup_de_grace", "perk.fast_adaption", "perk.dodge", "perk.student", "perk.taunt"];
gt.Const.BackgroundPerks.Data["background.refugee"] <- ["perk.bags_and_belts", "perk.pathfinder", "perk.nine_lives", "perk.backstabber", "perk.hold_out", "perk.gifted"];
gt.Const.BackgroundPerks.Data["background.retired_soldier"] <- ["perk.rally_the_troops", "perk.shield_expert", "perk.fortified_mind", "perk.rotation", "perk.nine_lives", "perk.anticipation"];
gt.Const.BackgroundPerks.Data["background.sellsword"] <- ["perk.shield_expert", "perk.bullseye", "perk.rotation", "perk.brawny", "perk.coup_de_grace", "perk.taunt"];
gt.Const.BackgroundPerks.Data["background.servant"] <- ["perk.student", "perk.quick_hands", "perk.gifted", "perk.recover", "perk.relentless", "perk.pathfinder"];
gt.Const.BackgroundPerks.Data["background.shepherd"] <- ["perk.fast_adaption", "perk.dodge", "perk.nine_lives", "perk.bags_and_belts", "perk.pathfinder", "perk.student"];
gt.Const.BackgroundPerks.Data["background.squire"] <- ["perk.shield_expert", "perk.steel_brow", "perk.rotation", "perk.brawny", "perk.adrenaline", "perk.taunt"];
gt.Const.BackgroundPerks.Data["background.swordmaster"] <- ["perk.relentless", "perk.backstabber", "perk.crippling_strikes", "perk.recover", "perk.brawny", "perk.fast_adaption"];
gt.Const.BackgroundPerks.Data["background.tailor"] <- ["perk.student", "perk.quick_hands", "perk.fast_adaption", "perk.fortified_mind", "perk.bullseye", "perk.hold_out"];
gt.Const.BackgroundPerks.Data["background.thief"] <- ["perk.bags_and_belts", "perk.backstabber", "perk.quick_hands", "perk.gifted", "perk.student", "perk.anticipation"];
gt.Const.BackgroundPerks.Data["background.vagabond"] <- ["perk.bags_and_belts", "perk.pathfinder", "perk.nine_lives", "perk.fast_adaption", "perk.dodge", "perk.relentless"];
gt.Const.BackgroundPerks.Data["background.wildman"] <- ["perk.colossus", "perk.pathfinder", "perk.crippling_strikes", "perk.adrenaline", "perk.steel_brow", "perk.brawny"];
gt.Const.BackgroundPerks.Data["background.witchhunter"] <- ["perk.bullseye", "perk.anticipation", "perk.fortified_mind", "perk.fast_adaption", "perk.pathfinder", "perk.hold_out"];

gt.Const.BackgroundPerks.TraitCost["trait.asthmatic"] <- -10;
gt.Const.BackgroundPerks.TraitCost["trait.bright"] <- 5;
gt.Const.BackgroundPerks.TraitCost["trait.craven"] <- -5;
gt.Const.BackgroundPerks.TraitCost["trait.dastard"] <- -5;
gt.Const.BackgroundPerks.TraitCost["trait.deathwish"] <- 5;
gt.Const.BackgroundPerks.TraitCost["trait.determined"] <- 5;
gt.Const.BackgroundPerks.TraitCost["trait.dumb"] <- -5;
gt.Const.BackgroundPerks.TraitCost["trait.fearless"] <- 5;
gt.Const.BackgroundPerks.TraitCost["trait.fragile"] <- -5;
gt.Const.BackgroundPerks.TraitCost["trait.hesitant"] <- -5;
gt.Const.BackgroundPerks.TraitCost["trait.insecure"] <- -5;
gt.Const.BackgroundPerks.TraitCost["trait.iron_jaw"] <- 5;
gt.Const.BackgroundPerks.TraitCost["trait.iron_lungs"] <- 10;
gt.Const.BackgroundPerks.TraitCost["trait.old"] <- -10;
gt.Const.BackgroundPerks.TraitCost["trait.quick"] <- 5;
gt.Const.BackgroundPerks.TraitCost["trait.strong"] <- 5;
gt.Const.BackgroundPerks.TraitCost["trait.superstitious"] <- -5;
gt.Const.BackgroundPerks.TraitCost["trait.tough"] <- 5;

gt.Const.BackgroundPerks.findById <- function ( _backgroundID )
{
	if (_backgroundID != null && _backgroundID in this.Const.BackgroundPerks.Data)
	{
		this.logDebug("BackgroundPerks.findById " + _backgroundID);
		return this.Const.BackgroundPerks.Data[_backgroundID];
	}

	return [];
};

gt.Const.BackgroundPerks.GetTraitCostById <- function ( _traitID )
{
	if (_traitID != null && _traitID in this.Const.BackgroundPerks.TraitCost)
	{
		return this.Const.BackgroundPerks.TraitCost[_traitID];
	}

	return 0;
};