this.bolas_item <- this.inherit("scripts/items/accessory/accessory", {
	m = {},
	function create()
	{
		this.accessory.create();
		this.m.ID = "accessory.bolas";
		this.m.Name = "Bolas";
		this.m.Description = "Weapon is made of weights on the ends of interconnected cords, used to capture animals by entangling their legs.";
		this.m.SlotType = this.Const.ItemSlot.Bag;
		this.m.IsAllowedInBag = true;
		this.m.IsDroppedAsLoot = true;
		this.m.ShowOnCharacter = false;
		this.m.IconLarge = "";
		this.m.Icon = "consumables/bolas_70x70.png";
		this.m.StaminaModifier = -5;
		this.m.Value = 250;
	}

	function getTooltip()
	{
		local result = this.accessory.getTooltip();
		return result;
	}

	function onEquip()
	{
		this.accessory.onEquip();
		local skill = this.new("scripts/skills/actives/throw_bolas_skill");
		skill.setItem(this);
		this.addSkill(skill);
	}

	function onPutIntoBag()
	{
		this.onEquip();
	}
});
